package com.qmth.teachcloud.mark.service.impl;

import java.io.IOException;
import java.io.InputStream;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.aliyuncs.http.FormatType;
import com.qmth.boot.core.exception.StatusException;
import com.qmth.boot.core.fss.store.FileStore;
import com.qmth.boot.tools.uuid.FastUUID;
import com.qmth.teachcloud.mark.enums.FileType;
import com.qmth.teachcloud.mark.service.FileService;

@Service
public class FileServiceImpl implements FileService {

    @Autowired
    private FileStore fileStore;

    @Override
    public String getAnswerCardUri(Long examId, Integer number) {
        return FileType.CARD.getPath(examId, number, FormatType.JSON.name().toLowerCase());
    }


    @Override
    public String uploadAnswerCard(InputStream in, String md5, Long examId, Integer number) {
    	String path = getAnswerCardUri(examId, number);
        try {
            fileStore.write(path, in, md5);
            return path;
        } catch (RuntimeException e) {
            throw e;
        } catch (Exception e) {
            throw new StatusException("文件上传出错:"+path, e);
        } finally {
            if (in != null) {
                try {
                    in.close();
                } catch (IOException e) {
                }
            }
        }
    }
    @Override
    public String uploadAdapteFile(InputStream in, String md5, Long examId, Integer number) {
    	String path = getAdapteFileUri(examId, number);
        try {
            fileStore.write(path, in, md5);
            return path;
        } catch (RuntimeException e) {
            throw e;
        } catch (Exception e) {
            throw new StatusException("文件上传出错:"+path, e);
        } finally {
            if (in != null) {
                try {
                    in.close();
                } catch (IOException e) {
                }
            }
        }
    }

    @Override
    public String getAdapteFileUri(Long examId, Integer cardNumber) {
        return FileType.ADAPTE_FILE.getPath(examId, cardNumber, FastUUID.get(), FormatType.JSON.name().toLowerCase());
    }
}
